
function initAddSitesDialog() {
	
	//createOptionsDialog();
	
	dojo.connect(dojo.byId("localType"),  "onclick", function () {
		updateDialogRows();
	});
	
	dojo.connect(dojo.byId("remoteType"),  "onclick", function() {
		updateDialogRows();
	});
	
	dojo.connect(dojo.byId("remoteType"),  "onfocus", function() {
		createLocalTooltip();
	});
	
	dojo.connect(dojo.byId("cancelSiteXMLUploadButton"),  "onfocus", function() {
		createLocalTooltip();
	});
	
	dojo.connect(dojo.byId("localType"),  "onmouseover", function() {
		createLocalTooltip();
		var currTooltip = dijit.byId('local_tooltip');
		if (currTooltip != undefined) {
			currTooltip.open();
		}
	});
	
	dojo.connect(dijit.byId('optionsDialog'), "hide", handleLocalCancel);
	
/*	dijit.byId("sitename").validator = function (value, constraints) {
	
		var valid = value!="";
		setAttribute('okSiteXMLUploadButton', 'disabled', !valid);
		return valid;
	}
*/
}

function setLocal(isLocal)
{
	setAttribute('localType', 'checked', isLocal);
	setAttribute('remoteType', 'checked', !isLocal);
	updateDialogRows();
}



function siteDialogOK()
{
	destroyLocalTooltip();
	
	var name = dijit.byId('sitename').value;
	var isLocal = dijit.byId("localType").getValue()=="on";
	var href;
	if (isLocal && dijit.byId('optionsDialog').mode=="add")
		href = document.getElementById("fileInput").value;
	else
		href = dijit.byId('siteURL').value;
	
	if (dijit.byId('optionsDialog').mode=="add" && !isLocal)
		siteAdded(name,href);
	else if (dijit.byId('optionsDialog').mode=="add" &&isLocal)
	{
		siteUploaded(name);
	}
	else
	{
		var oldName = dijit.byId('prevName').value;
		var oldHref = dijit.byId('prevFile').value;
		siteEdited(oldName,oldHref,name,href);
	}
		
	resetDialog();
}

function addSite()
{
	initSiteDialog(addSitelbl_msg, "", "", true,true);
	dijit.byId('optionsDialog').show();
}

function siteAdded(name,href)
{
	if (name=="" || href=="")
		return;
		
	dijit.byId('optionsDialog').hide();
	
	var bar = getProgressBar();
	bar.runIndeterminate(updateGridPopuplbl_msg);
	
	dojo.xhrPut({
		url: '../com.ibm.ccl.help.webapp.war.updater.servlets.SiteService?name='+escape(name)+'&href='+escape(href),
		handleAs: "text",
		load: function(data, ioArgs) {
			getProgressBar().setVisible(false);
			if (data != "")
				alertError(unescape(data));
			refreshTree();			
			updateInstalledFeatureGrid('true');
		},
		error: function() {
			getProgressBar().setVisible(false);
			refreshTree();
		}
	});
}
function siteUploaded(siteName) {
	
	var fileInput = document.getElementById("fileInput");
	dojo.io.iframe.send({ 
		url: "config?op=UploadSite&name="+siteName+"&xid="+siteName,
		method: "post",
		form: 'fileForm',
		handleAs: 'text',
		load: function(response,ioArgs){
			refreshTree();
			return response;
		}
	});		
	
	
	dijit.byId('optionsDialog').hide();
	
	var bar = getProgressBar();
	bar.runIndeterminate(updateGridPopuplbl_msg);
	
	refreshAfterUpload(siteName);
}

function refreshAfterUpload(id)
{
	dojo.xhrGet({
		url: 'state',
		handleAs: "text",
		content: {
			xid: id,
			lang: LANG
		},
		load: function(data, ioArgs) {
			if (data.indexOf("<percent>100</percent>")>-1) {
				refreshTree();
				getProgressBar().setVisible(false);
				
				if (data.indexOf("<error></error")==-1)
					alertError(errorConnectmsg_msg+"\n"+data.substring(data.indexOf("<error>")+7,data.indexOf("</error>")));
				
			}else{
				setTimeout("refreshAfterUpload('"+id+"')",1500);
			}
		}
	});
}
function editSitePopup() {
	editSite(
		unescape(getValue(POPUP_MENU_SELECTED_TREENODE.item, 'title')),
		unescape(getValue(POPUP_MENU_SELECTED_TREENODE.item, 'link')));
}


function editSiteButton() {

	if ((SelectedLocalEntries.count != 1) || (ROOT_TREE_STORE_ITEMS==null))
		return;
			
	var selectedItem = SelectedLocalEntries.item(0);
	var tokens = selectedItem.split(',');
			
	if (tokens.length == 2 && tokens[1] != "") {				
		var item = findItemByIdentify(ROOT_TREE_STORE_ITEMS, 'uid', tokens[1] );
		editSite(unescape(getValue(item,'title')),unescape(getValue(item,'link')));
	}
}

function editSite(title,link) 
{	

	initSiteDialog(viewEditSitelbl_msg, title, link, link.indexOf("http")!=0,false);
	dijit.byId('optionsDialog').show();
}

function siteEdited(oldName,oldHref,newName,newHref)
{
	if (oldName=="" || newName=="" || oldHref=="" || newHref=="")
		return;

	dojo.xhrPost({
		url: '../com.ibm.ccl.help.webapp.war.updater.servlets.SiteService?name='+escape(oldName)+'&href='+escape(oldHref)+'&newName='+escape(newName)+'&newHref='+escape(newHref),
		handleAs: "text",
		load: function(data, ioArgs) {
			if (data != "")
				alertError(unescape(data));
			refreshTree();			
			updateInstalledFeatureGrid('true');
		},
		error: function() {
			refreshTree();
		}
	});
}

function removeSitePopup() {
	var site = getValue(POPUP_MENU_SELECTED_TREENODE.item, 'title');
	siteRemoved(site);
}
function removeSite() {
	
	var item = dijit.byId("tree").attr("selectedItem").i.title;
	siteRemoved(item);
}

function siteRemoved(site)
{
	if (site=="")
		return;

	dojo.xhrDelete({
		url: '../com.ibm.ccl.help.webapp.war.updater.servlets.SiteService?names='+escape(site),
		handleAs: "text",
		load: function(data, ioArgs) {
			if (data != "")
				alertError(unescape(data));
			refreshTree();			
			updateInstalledFeatureGrid('true');
		},
		error: function() {
			refreshTree();
		}
	});
}

function initSiteDialog(title, siteName, siteURL, isLocal, isNew)
{
	dijit.byId("sitename").setValue(siteName);
	dijit.byId("prevName").setValue(siteName);
	dijit.byId("prevFile").setValue(siteURL);
	dijit.byId("siteURL").setValue(siteURL);
	
	if (isNew){
		dijit.byId('optionsDialog').mode="add";
		dijit.byId("localType").setDisabled(false);
		dijit.byId("remoteType").setDisabled(false);
	} 
	else{
		dijit.byId('optionsDialog').mode="edit"; 
		dijit.byId("localType").setDisabled(true);
		dijit.byId("remoteType").setDisabled(true);
	} 
	
	setLocal(isLocal);
	setDialogRows(isLocal,isNew);
	
}


function updateDialogRows(isLocal,isNew) {
	
	var isLocal = dijit.byId("localType").getValue()=="on";
	var isNew = dijit.byId('optionsDialog').mode=="add"

	setDialogRows(isLocal,isNew);
}

function setDialogRows(isLocal,isNew) {
	
	
	var localRow = document.getElementById("localRow");
	var remoteRow = document.getElementById("remoteRow");
	var prevRow = document.getElementById("prevRow");

	if (isLocal)
	{
		if (isNew)
		{
			localRow.style.display="";
			prevRow.style.display="none";
		}
		else
		{
			localRow.style.display="none";
			prevRow.style.display="";
		}
		remoteRow.style.display="none";
	}
	else
	{
		localRow.style.display="none";
		prevRow.style.display="none";
		remoteRow.style.display="";
	}
	
}

function setSiteDialog(title, siteName, isLocal, href, mode) {
	
	dijit.byId("sitename").setValue(siteName);
	
	dijit.byId("prevName").setValue(siteName);
	dijit.byId("prevFile").setValue(href);
	
	setLocal(isLocal);
	
	var dialog = dijit.byId("optionsDialog");
	dialog.titleNode.innerHTML = title || "";
	dialog.mode = mode;
}


function resetDialog() {
	
	dijit.byId("sitename").setValue("");
	dijit.byId("siteURL").setValue("");
	document.getElementById("fileInput").value="";

	dojo.byId("helpButton").style.display = 'none';
}

function createLocalTooltip() {
	
	var tooltipLabel = "<table width=\'285px\' cellpadding=0 cellspacing=0><tr><td align=\'left\'><b>Local</b></td></tr><tr><td align=\'left\'><ul><li>Provide the path of the <b><font color=\'#000080\'>updateSite.zip</font></b> file available locally</li></ul></td></tr></table>";
	createTooltipById('local_tooltip', tooltipLabel, 'localType');
}

function destroyLocalTooltip() {
	
	destroyTooltipById('local_tooltip');
}

function handleLocalCancel() {
	
	destroyLocalTooltip();
	resetDialog();
}




